#ifndef LNMETA_H
#define LNMETA_H

/*
       -  


 :
[ hex ]/[ text:
	   [ unwrap/wrap/wordwrap(   ) ]
	]
*/

// **********************************************************************
//      ( c )
class	Tlnmeta;
typedef Tlnmeta *Tlnmeta_p;

//    
class   Tlnmeta_mode;
typedef Tlnmeta_mode *Tlnmeta_mode_p;

//   
class	Tlnmeta_mode_lnstream;
typedef Tlnmeta_mode_lnstream *Tlnmeta_mode_lnstream_p;

// **********************************************************************
//    - 
class	Tlnmeta_mode_lnstream_sel;
typedef Tlnmeta_mode_lnstream_sel *Tlnmeta_mode_lnstream_sel_p;

//    - 
template <class Tuser_lnstream>
class	Tlnmeta_mode_lnstream_call;

// **********************************************************************
//    
// **********************************************************************
class   Tlnmeta_mode:virtual public Toos
{
// 
	//   ,   . 
	//  
	SELF_Toos

//  
public:
	//  
	virtual	t_err	set_submode_number(u_int mode_number);

	//  
	virtual	u_int	get_submode_number()
	 {return submodes.get_index();}

	// 
	virtual	u_int	get_submodes()
	 {return submodes.get_items();}

	//     
	virtual	Tlnmeta_mode_p get_submode()
	 {return Tlnmeta_mode_p(-submodes);}

protected:
	// (submodes)
	Tplist	submodes;

//  o
public:
	//  
	virtual char_p	mode_description()=0;

	//   
	virtual t_err	mode_prepare();
};

// **********************************************************************
//   
// **********************************************************************
class	Tlnmeta_mode_lnstream:
	public Tlnmeta_mode,
	public Tline_stream
{
public:
	inline Tlnmeta_mode_lnstream(Tstream& user_stream):
				      stream(user_stream){}

	//   -
	virtual Tstream&  get_stream()
	 {return stream;}

// 
public:
	// /  
	//   . 
	CALL_Toos
	 {
	  return Tstream::oos(oper,f);
	 }
	//   ,   . 
	//  
	SELF_Toos

//  
protected:
	//  
	void 	set_pos(int pos,int whence=SEEK_SET)
	 {stream.set_pos(pos,whence);}
	//   SEEK_SET
	u_int	get_pos()
	 {return stream.get_pos();}
	// 
	u_int	fsize()
	 {return stream.fsize();}
	// " "
	int	eof()
	 {return stream.eof();}

	// 
	int	read_ch()
	 {return stream.read_ch();}
	// 
	int	read_block( void* dst, u_int size )
	 {return stream.read_block(dst,size);}

private:
	// 
	Tstream& stream;
};

// **********************************************************************
//    - 
class	Tlnmeta_mode_lnstream_sel:public Tlnmeta_mode_lnstream
{
public:
	inline Tlnmeta_mode_lnstream_sel(Tstream& user_stream):
	       Tlnmeta_mode_lnstream(user_stream){}

// 
public:
	//   ,   . 
	//  
	SELF_Toos

//  
public:
	//    ( tty \?)  
	//return NULL on error or feof()
	//Tstring_p need external delete
	Tstring_p read();
	//   line,  ! ERR_BOUND
	t_err	seek(u_int line);
	//       
	u_int	get_lines();
	//  seek
	u_int	get_percent();
	//     -1 on error
	u_int	get_line();
	//  seek
	u_int	get_last_seek();

//    
public:
	//     ,  ! ERR_BOUND
	//      
	t_err	next_line();
	// :   lx
	void 	line_discipline(u_int lx);

protected:
	//  
	//  Tstring   
	void 	convert(Tstring& str);
};

// **********************************************************************
//    - 
template <class Tuser_lnstream>
class	Tlnmeta_mode_lnstream_call:
	public Tlnmeta_mode_lnstream,
	public Tuser_lnstream
{
public:
	inline Tlnmeta_mode_lnstream_call(Tstream& user_stream):
	       Tlnmeta_mode_lnstream(user_stream){}

// 
public:
	// /  
	//   . 
	CALL_Toos
	 {
	  t_err		res;
	  //warn("Tlnmeta_mode_lnstream_call::oss CALLED");
	  if(
	     ( (res=(oper==OBJ_LOAD)?
		     Tstream_state::obj_load(f):
		     Tstream_state::obj_save(f))!=ERR_NO )
	    )return res;
	  //warn("Tlnmeta_mode_lnstream_call::oss OK");
	  return Toos::oos(oper,f);
	 }

	//   ,   . 
	//  
	//SELF_Toos

	//  , / . . 
	t_err	obj_load(FILE *fi)
	{
	 t_err		res;

		 if(!fi)return err(ERR_ZPAR);

		 if(
		    ( (res=Tlnmeta_mode_lnstream::obj_load(fi))!=ERR_NO )
		    ||( (res=Tuser_lnstream::obj_load(fi))!=ERR_NO )
		   )return res;
		 return ERR_NO;

	}
	//  , / . . 
	t_err	obj_save(FILE *fo)
	{
	 t_err		res;
	  //warn("Tlnmeta_mode_lnstream_call::obj_save CALLED");
		 if(!fo)return err(ERR_ZPAR);

		 if(
		    ( (res=Tlnmeta_mode_lnstream::obj_save(fo))!=ERR_NO )
		    ||( (res=Tuser_lnstream::obj_save(fo))!=ERR_NO )
		   )return res;
	  //warn("Tlnmeta_mode_lnstream_call<%s>::obj_save OK");
		 return ERR_NO;
	}

//  
public:
	//    ( tty \?)  
	//return NULL on error or feof()
	//Tstring_p need external delete
	Tstring_p read()
	 {return Tuser_lnstream::read();}
	//   line,  ! ERR_BOUND
	t_err	seek(u_int line)
	 {return Tuser_lnstream::seek(line);}
	//       
	u_int	get_lines()
	 {return Tuser_lnstream::get_lines();}
	//  seek
	u_int	get_percent()
	 {return Tuser_lnstream::get_percent();}
	//     -1 on error
	u_int	get_line()
	 {return Tuser_lnstream::get_line();}
	//  seek
	u_int	get_last_seek()
	 {return Tuser_lnstream::get_last_seek();}

//    
public:
	//     ,  ! ERR_BOUND
	//      
	t_err	next_line()
	 {return Tuser_lnstream::next_line();}
	// :   lx
	void 	line_discipline(u_int lx)
	 {Tuser_lnstream::line_discipline(lx);}

protected:
	//  
	//  Tstring   
	void 	convert(Tstring& str)
	 {Tuser_lnstream::convert(str);}

//  
protected:
	//  
	void 	set_pos(int pos,int whence=SEEK_SET)
	 {Tlnmeta_mode_lnstream::set_pos(pos,whence);}
	//   SEEK_SET
	u_int	get_pos()
	 {return Tlnmeta_mode_lnstream::get_pos();}
	// 
	u_int	fsize()
	 {return Tlnmeta_mode_lnstream::fsize();}
	// " "
	int	eof()
	 {return Tlnmeta_mode_lnstream::eof();}

	// 
	int	read_ch()
	 {return Tlnmeta_mode_lnstream::read_ch();}
	// 
	int	read_block( void* dst, u_int size )
	 {return Tlnmeta_mode_lnstream::read_block(dst,size);}
};

// **********************************************************************
//      ( c )
// **********************************************************************
class	Tlnmeta:public Tlnmeta_mode_lnstream_sel
{
public:
	//   
	Tlnmeta(Tstream& user_stream);

// 
	//   ,   . 
	//  
	SELF_Toos

//  o
public:
	//  
	char_p	mode_description(){return "Tlnmeta";}
};

// **********************************************************************
#endif
