#ifndef KEYS_H
#define KEYS_H

/*
	     getch()
*/

/* keys */
typedef enum{
	KEY_ESC=0,
	KEY_F1,
	KEY_F2,
	KEY_F3,
	KEY_F4,
	KEY_F5,
	KEY_F6,
	KEY_F7,
	KEY_F8,
	KEY_F9,
	KEY_F10,
	KEY_F11,
	KEY_F12,
	KEY_TILDA,
	KEY_1,
	KEY_2,
	KEY_3,
	KEY_4,
	KEY_5,
	KEY_6,
	KEY_7,
	KEY_8,
	KEY_9,
	KEY_0,
	KEY_MINES,
	KEY_EQU,
	KEY_BK_SLASH,
	KEY_BK_SPACE,
	KEY_TAB,
	KEY_Q,
	KEY_W,
	KEY_E,
	KEY_R,
	KEY_T,
	KEY_Y,
	KEY_U,
	KEY_I,
	KEY_O,
	KEY_P,
	KEY_OP_BRACE,
	KEY_CL_BRACE,
	KEY_ENTER,
	KEY_A,
	KEY_S,
	KEY_D,
	KEY_F,
	KEY_G,
	KEY_H,
	KEY_J,
	KEY_K,
	KEY_L,
	KEY_COLON,
	KEY_QUOTE,
	KEY_Z,
	KEY_X,
	KEY_C,
	KEY_V,
	KEY_B,
	KEY_N,
	KEY_M,
	KEY_LESS,
	KEY_MORE,
	KEY_SLASH,
	KEY_SPACE,
	KEY_INSERT,
	KEY_DEL,
	KEY_HOME,
	KEY_END,
	KEY_PD_UP,
	KEY_PD_DN,
	KEY_CR_LF,
	KEY_CR_RT,
	KEY_CR_UP,
	KEY_CR_DN,
}t_keys;
#define KEY_KEYS	(KEY_CR_DN+1)

/*  */
typedef enum{
	KEY_MOD_NO=0,
	KEY_MOD_CTRL,
	KEY_MOD_ALT,
	KEY_MOD_SHIFT
}t_keymods;

#define KEY_MODS    	(KEY_MOD_SHIFT+1)

/*         */
extern	char_p	key_names[KEY_KEYS];
extern	char_p	keymod_names[KEY_MODS];

/* C++         */
extern	char_p	key_c_names[KEY_KEYS];
extern	char_p	keymod_c_names[KEY_MODS];

/* *************************************************************** */
#endif
