#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#include <mydef.h>
#include <tstring.h>

#pragma hdrstop

#include <unicode.h>

#include "plist\plist.h"

#include "tstream\tstream.h"
#include "linestrm\linestrm.h"
#include "linestrm\lnstrmh.h"
#include "linestrm\lnstrmt.h"
#include "linestrm\lnstrmtu.h"
#include "linestrm\lnstrmtw.h"
#include "linestrm\lnstrmtx.h"

#include "linestrm\lnmeta\lnmeta.h"
#include "linestrm\lnmeta\lnmetam.h"
/*
	  lnmeta
*/

// **********************************************************************
//    
// **********************************************************************
//  , / . . 
t_err	Tlnmeta_mode::obj_load(FILE *fi)
{
t_err		res;
u_int		i,j,a,r;

	if(!fi)return err(ERR_ZPAR);

	r=get_submodes();

	// 
	fread(&j,1,sizeof(j),fi);
	if(!j)return ERR_NO;

	//    
	if(r!=j)return ERR_BADFORMAT;

	// 
	fread(&a,1,sizeof(a),fi);
	if(a>=r)return ERR_BADFORMAT;

	//  
Tplist_iterator		pi(submodes);

	pi[0];
	for(i=0;i<j;i++)
	 {
	  res=Tlnmeta_mode_p(-pi)->oos(OBJ_LOAD,fi);
	  pi++;
	  if(res!=ERR_NO)return res;
	 }

	set_submode_number(a);

	//fread(&,1,sizeof(),fi);

	return ERR_NO;
}

// **********************************************************************
//  , / . . 
t_err	Tlnmeta_mode::obj_save(FILE *fo)
{
t_err		res;
u_int		i,j;

	if(!fo)return err(ERR_ZPAR);

	// 
	j=get_submodes();
	fwrite(&j,1,sizeof(j),fo);

	if(!j)return ERR_NO;

	// 
	i=get_submode_number();
	fwrite(&i,1,sizeof(i),fo);

	//  
Tplist_iterator		pi(submodes);

	pi[0];
	for(i=0;i<j;i++)
	 {
	  //?      save
	  res=Tlnmeta_mode_p(-pi)->oos(OBJ_SAVE,fo);
	  pi++;
	  if(res!=ERR_NO)return res;
	 }

	//fwrite(&,1,sizeof(),fo);

	return ERR_NO;
}

// **********************************************************************
//   
// **********************************************************************
//  , / . . 
t_err	Tlnmeta_mode_lnstream::obj_load(FILE *fi)
{
t_err		res;

	if(!fi)return err(ERR_ZPAR);

	if(
	   ( (res=Tline_stream::obj_load(fi))!=ERR_NO )
	   ||( (res=Tlnmeta_mode::obj_load(fi))!=ERR_NO )
	  )return res;
	return ERR_NO;
}

// **********************************************************************
//  , / . . 
t_err	Tlnmeta_mode_lnstream::obj_save(FILE *fo)
{
t_err		res;

	if(!fo)return err(ERR_ZPAR);

	if(
	   //  Tline_stream      
	   ( (res=Tline_stream::obj_save(fo))!=ERR_NO )
	   ||( (res=Tlnmeta_mode::obj_save(fo))!=ERR_NO )
	  )return res;
	return ERR_NO;
}

// **********************************************************************
//    - 
// **********************************************************************
//  , / . . 
t_err	Tlnmeta_mode_lnstream_sel::obj_load(FILE *fi)
{
t_err		res;

	if(!fi)return err(ERR_ZPAR);

	if(
	   ( (res=Tlnmeta_mode_lnstream::obj_load(fi))!=ERR_NO )
	  )return res;
	return ERR_NO;
}

// **********************************************************************
//  , / . . 
t_err	Tlnmeta_mode_lnstream_sel::obj_save(FILE *fo)
{
t_err		res;

	if(!fo)return err(ERR_ZPAR);

	if(
	   ( (res=Tlnmeta_mode_lnstream::obj_save(fo))!=ERR_NO )
	  )return res;
	return ERR_NO;
}
// **********************************************************************
//      ( c )
// **********************************************************************
//  , / . . 
t_err	Tlnmeta::obj_load(FILE *fi)
{
t_err		res;

	if(!fi)return err(ERR_ZPAR);

	if(
	   ( (res=Tlnmeta_mode_lnstream_sel::obj_load(fi))!=ERR_NO )
	  )return res;
	return ERR_NO;
}
// **********************************************************************
//  , / . . 
t_err	Tlnmeta::obj_save(FILE *fo)
{
t_err		res;

	if(!fo)return err(ERR_ZPAR);

	if(
	   ( (res=Tlnmeta_mode_lnstream_sel::obj_save(fo))!=ERR_NO )
	  )return res;
	return ERR_NO;
}

// **********************************************************************
//Tlnmeta_mode_hex
// **********************************************************************
//  , / . . 
t_err	Tlnmeta_mode_hex::obj_load(FILE *fi)
{
t_err		res;

	if(!fi)return err(ERR_ZPAR);
	//warn("Tlnmeta_mode_hex::obj_load CALLED");
	if(
	   ( (res=Tlnmeta_mode_lnstream_call<Tlnstream_hex>::obj_load(fi))!=ERR_NO )
	  )return res;
	//warn("Tlnmeta_mode_hex::obj_load OK");
	return ERR_NO;
}
// **********************************************************************
//  , / . . 
t_err	Tlnmeta_mode_hex::obj_save(FILE *fo)
{
t_err		res;

	if(!fo)return err(ERR_ZPAR);

	//warn("Tlnmeta_mode_hex::obj_save CALLED");
	if(
	   ( (res=Tlnmeta_mode_lnstream_call<Tlnstream_hex>::obj_save(fo))!=ERR_NO )
	  )return res;
	//warn("Tlnmeta_mode_hex::obj_save OK");
	return ERR_NO;
}

// **********************************************************************
//Tlnmeta_mode_unwrap
// **********************************************************************
//  , / . . 
t_err	Tlnmeta_mode_unwrap::obj_load(FILE *fi)
{
t_err		res;

	if(!fi)return err(ERR_ZPAR);

	if(
	   ( (res=Tlnmeta_mode_lnstream_call<Tlnstream_unwrap>::obj_load(fi))!=ERR_NO )
	  )return res;
	return ERR_NO;
}
// **********************************************************************
//  , / . . 
t_err	Tlnmeta_mode_unwrap::obj_save(FILE *fo)
{
t_err		res;

	if(!fo)return err(ERR_ZPAR);

	if(
	   ( (res=Tlnmeta_mode_lnstream_call<Tlnstream_unwrap>::obj_save(fo))!=ERR_NO )
	  )return res;
	return ERR_NO;
}

// **********************************************************************
//Tlnmeta_mode_wrap
// **********************************************************************
//  , / . . 
t_err	Tlnmeta_mode_wrap::obj_load(FILE *fi)
{
t_err		res;

	if(!fi)return err(ERR_ZPAR);

	if(
	   ( (res=Tlnmeta_mode_lnstream_call<Tlnstream_wrap>::obj_load(fi))!=ERR_NO )
	  )return res;
	return ERR_NO;
}
// **********************************************************************
//  , / . . 
t_err	Tlnmeta_mode_wrap::obj_save(FILE *fo)
{
t_err		res;

	if(!fo)return err(ERR_ZPAR);

	if(
	   ( (res=Tlnmeta_mode_lnstream_call<Tlnstream_wrap>::obj_save(fo))!=ERR_NO )
	  )return res;
	return ERR_NO;
}

// **********************************************************************
//Tlnmeta_mode_wordwrap
// **********************************************************************
//  , / . . 
t_err	Tlnmeta_mode_wordwrap::obj_load(FILE *fi)
{
t_err		res;

	if(!fi)return err(ERR_ZPAR);

	if(
	   ( (res=Tlnmeta_mode_lnstream_call<Tlnstream_wordwrap>::obj_load(fi))!=ERR_NO )
	  )return res;
	return ERR_NO;
}
// **********************************************************************
//  , / . . 
t_err	Tlnmeta_mode_wordwrap::obj_save(FILE *fo)
{
t_err		res;

	if(!fo)return err(ERR_ZPAR);

	if(
	   ( (res=Tlnmeta_mode_lnstream_call<Tlnstream_wordwrap>::obj_save(fo))!=ERR_NO )
	  )return res;
	return ERR_NO;
}

// **********************************************************************
//Tlnmeta_mode_text
// **********************************************************************
//  , / . . 
t_err	Tlnmeta_mode_text::obj_load(FILE *fi)
{
t_err		res;

	if(!fi)return err(ERR_ZPAR);

	if(
	   ( (res=Tlnmeta_mode_lnstream_sel::obj_load(fi))!=ERR_NO )
	  )return res;
	return ERR_NO;
}
// **********************************************************************
//  , / . . 
t_err	Tlnmeta_mode_text::obj_save(FILE *fo)
{
t_err		res;

	if(!fo)return err(ERR_ZPAR);

	if(
	   ( (res=Tlnmeta_mode_lnstream_sel::obj_save(fo))!=ERR_NO )
	  )return res;
	return ERR_NO;
}

// **********************************************************************
