#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#include <mydef.h>
#include <tstring.h>

#pragma hdrstop

#include <unicode.h>

#include "tstream\tstream.h"
#include "linestrm\linestrm.h"
#include "linestrm\lnstrmt.h"
#include "linestrm\lnstrmtu.h"
#include "linestrm\lnstrmtw.h"
#include "linestrm\lnstrmtx.h"

// **********************************************************************
// 
// **********************************************************************
//  , / . . 
t_err	Tlnstream_wordwrap::obj_load(FILE *fi)
{
t_err		res;

	if(!fi)return err(ERR_ZPAR);

	if( (res=Tlnstream_unwrap::obj_load(fi))!=ERR_NO )
	 return res;

	fread(&win_lx,1,sizeof(win_lx),fi);

	return ERR_NO;
}

// **********************************************************************
//  , / . . 
t_err	Tlnstream_wordwrap::obj_save(FILE *fo)
{
t_err		res;

	if(!fo)return err(ERR_ZPAR);

	if( (res=Tlnstream_unwrap::obj_save(fo))!=ERR_NO )
	 return res;

	fwrite(&win_lx,1,sizeof(win_lx),fo);

	return ERR_NO;
}

// **********************************************************************
//    
// **********************************************************************
//   ,  ! ERR_BOUND
//      
t_err	Tlnstream_wordwrap::next_line()
{
int		ch;
u_int          	word_size;
/*
	{
	 char s[80];

	 sprintf(s,"usage wrap\nlx=%u",win_lx);
	 warn(s);
	}
*/
	//    
	converted_line_size=0;
	displayed_line_size=0;
	stream_line_size=0;

	word_size=0;

	while(1)
	 {
	  ch=read_ch();

	  //   <EOF>
	  if(eof())return ERR_BOUND;

	  //? 
	  if(u_char(ch)<=32)word_size=0;
	  else word_size++;

	  converted_line_size++;
	  stream_line_size++;
	  //format tty for display & load
	  switch(ch)
	   {
	    //   \n
	    case '\n':
	       return ERR_NO;
	    //skip \r
	    case '\r':
	       break;
	    //expand \t
	    case '\t':
	     {
	      u_int	dx=displayed_line_size%8;

	      //displayed_line_size+=8;
	      displayed_line_size+=(!dx)?8:dx;

	      converted_line_size+=7;
	     }break;

	    default: displayed_line_size++;
	   }

	  //   win_lx (wordwrap mode)
	  if(
	     (win_lx)                           //  
	     &&(displayed_line_size >= win_lx)  //  
	    )
	   {
	    if(
	       (word_size)			//    
	       &&(word_size < stream_line_size)	//     1 
	      )
	     {
	      set_pos(get_pos()-word_size);

	      stream_line_size-=word_size;
	      converted_line_size-=word_size;
	     }

	    //warn("wordwrap line");
	    return ERR_NO;
	   }

	 }
}

// **********************************************************************
// :   lx
void 	Tlnstream_wordwrap::line_discipline(u_int lx)
{
	if(win_lx!=lx)is_lines_counted=0;
	win_lx=lx;
}

// **********************************************************************

