#include "vbrouser\all.h"

#include "winitems.h"

// **********************************************************************
// 
// **********************************************************************
class	Tcwin_caption;
typedef Tcwin_caption *Tcwin_caption_p;

// **********************************************************************
// 
class	Tcwin_caption:public Twin
{
public:
	inline Tcwin_caption()
	 {
	  lines+=(Tlist_item_p)&caption;

	  color=WHITE;
	  bkcolor=BLUE;
	 }

//   
public:
	//   -    
	void 	set_size(u_int lx,u_int ly);

//  
public:
	// 
	Tstring	caption;
};

// **********************************************************************
//   -    
void 	Tcwin_caption::set_size(u_int new_lx,u_int new_ly)
{
	lx=new_lx;
	ly=(new_ly)?1:0;

	Twin::set_size(lx,ly);
}

// **********************************************************************
//<START>
//  
// **********************************************************************
//  
	Tcwin::Tcwin()
{
Tcwin_caption_p		c;
Twin_list_item_p	p;

	//
	c=new Tcwin_caption;
	if(!c){err(ERR_NOMEM);return;}

	p=new Twin_list_item(*c);
	if(!p){err(ERR_NOMEM);return;}

	children[0];
	children+=p;

	// 
	hide_self=1;
}

// **********************************************************************
//     
// **********************************************************************
//   
void	Tcwin::set_paper(Twin_p paper_p,char skip_set_size)
{
Twin_list_item_p	p;

	//?  paper 
	if(children.get_items() > CWIN_PAPER)
	 {
	  p=Twin_list_item_p(children[CWIN_PAPER]);
	  if(!p){err2(ERR_ZDATA,"child list error");}

	  //?    
	  if(p->win_need_free)
	    delete &(p->win);

	  //       
	  ~children;
	 }

	//? 
	if(!paper_p)return;

	//    
	p=new Twin_list_item(*paper_p);
	if(!p){err(ERR_NOMEM);return;}

	// 
	children[CWIN_PAPER?CWIN_PAPER-1:0];
	children+=p;

	if(!skip_set_size)set_size(lx,ly);
}

// **********************************************************************
//  
void 	Tcwin::set_caption(char_p acaption,char skip_set_size)
{
Tcwin_caption_p		w;

	// 
	w=Tcwin_caption_p(get_caption());

	if(!acaption)~w->caption;
	else w->caption=acaption;

	if(!skip_set_size)set_size(lx,ly);
}

// **********************************************************************
//    
Twin_p	Tcwin::get_caption()
{
Twin_list_item_p	p;

	// 
	p=(Twin_list_item_p)children[CWIN_CAPTION];
	if(!p){err2(ERR_ZDATA,"child list error");}
	return &(p->win);
}

// **********************************************************************
//    
Twin_p	Tcwin::get_paper()
{
Twin_list_item_p	p;
Twin_p			w=0;

	//?   
	if(children.get_items() > CWIN_PAPER)
	 {
	  p=(Twin_list_item_p)children[CWIN_PAPER];
	  if(!p){err2(ERR_ZDATA,"child list error");}
	  w=&(p->win);
	 }
	return w;
}

// **********************************************************************
//   
// **********************************************************************
//   -    
void	Tcwin::set_size(u_int new_lx,u_int new_ly)
{
Twin_list_item_p	p[2]={0,0};
u_int			ply;

	lx=new_lx;
	ly=new_ly;
	ply=ly;

	// 
	p[CWIN_CAPTION]=(Twin_list_item_p)children[CWIN_CAPTION];
	if(!p[CWIN_CAPTION]){err2(ERR_ZDATA,"child list error");}

	//?   
	if(children.get_items() > CWIN_PAPER)
	 {
	  p[CWIN_PAPER]=(Twin_list_item_p)children[CWIN_PAPER];
	  if(!p[CWIN_PAPER]){err2(ERR_ZDATA,"child list error");}
	 }

	//? 
	if(
	   (Tcwin_caption_p(&(p[CWIN_CAPTION]->win))->caption.len())
	   &&(
	      (ly>1)
	      ||( (ly)&&(!p[CWIN_PAPER]) )
	     )
	  )
	 {
	  p[CWIN_CAPTION]->win.hide(0);
	  p[CWIN_CAPTION]->win.set_size(lx,ly);

	  if(p[CWIN_PAPER])
	   {
	    p[CWIN_PAPER]->y=1;
	    ply--;
	   }
	 }
	else// 
	 {
	  if(p[CWIN_PAPER])
	   {
	    p[CWIN_CAPTION]->win.hide(1);
	    p[CWIN_PAPER]->y=0;
	   }
	 }

	if(p[CWIN_PAPER])p[CWIN_PAPER]->win.set_size(lx,ply);
}

// **********************************************************************
