#include "vbrouser\all.h"

#include "winitems.h"

// **********************************************************************
//   
// **********************************************************************
#pragma argsused
static	KEYB_ACTION(key_enter)
{
	Tdialog_p(obj_p)->on_exit=1;
	Tdialog_p(obj_p)->selected=1;
}
// **********************************************************************
#pragma argsused
static	KEYB_ACTION(key_exit)
{
	Tdialog_p(obj_p)->on_exit=1;
}
// **********************************************************************
//   
void 	Tdialog::sw_active()
{
	if(!is_active)
	 {
	  is_active=1;
	  //new keys
	  old_key[0]=desktop_p->keyb_p->replace( Tkeyb_key(KEY_ASCII,0x0d),key_enter,this);
	  old_key[1]=desktop_p->keyb_p->replace( Tkeyb_key(KEY_ASCII,0x1b),key_exit,this);
	  //children
	  Twin::sw_active();
	 }
	else
	 {
	  is_active=0;
	  //children
	  Twin::sw_active();
	  // 
	  desktop_p->keyb_p->install( Tkeyb_key(KEY_ASCII,0x1b),old_key[1]);
	  desktop_p->keyb_p->install( Tkeyb_key(KEY_ASCII,0x0d),old_key[0]);
	 }
}

// **********************************************************************
//   -    
void 	Tdialog::set_size(u_int new_lx,u_int new_ly)
{
	lx=new_lx;
	ly=new_ly;

	//    
	last_x=(lx<desktop_p->lx)?desktop_p->lx/2-lx/2:0;
	last_y=(ly<desktop_p->ly)?desktop_p->ly/2-ly/2:0;

	//  paper
	Tcwin::set_size(lx,ly);

	//      desktop
	set_reference(last_x,last_y);
}

// **********************************************************************
//  
// **********************************************************************
//  c    
u_int	Tdialog::execute(char clear_keys)
{
Tkeyb_actions		actions,*kp=0;

	//   
	if(clear_keys)
	 {
	  kp=desktop_p->keyb_p->get_keyb_actions();
	  if(kp)
	   {
	    actions=*kp;
	    kp->clear();
	   }
	 }

	// 
	sw_active();

	// 
	refresh(last_x,last_y);

	//  
	on_exit=0;
	selected=0;
	while(1)
	 {
	  desktop_p->keyb_p->action(KEYB_ACTION_WAIT);
	  if(on_exit)break;
	 }

	// 
	sw_active();

	//   
	if((clear_keys)&&(kp))
	 {
	  *kp=actions;
	 }

	//   
	if(selected)return DLG_OK;
	return DLG_CANCEL;
}

// **********************************************************************
