#include "lbrouser\all.h"

#include "winitems.h"
#include "lbrouser\lbrouser.h"
#include "lbrouser\lbpaper.h"
#include "lbrouser\lbpap_rs.h"

/*
	 lbPAPER
*/

// **********************************************************************
#pragma argsused
static KEYB_ACTION(lbpaper_kb_up){(Tlbpaper_p(obj_p))->up();}
// **********************************************************************
#pragma argsused
static KEYB_ACTION(lbpaper_kb_dn){(Tlbpaper_p(obj_p))->dn();}
// **********************************************************************
#pragma argsused
static KEYB_ACTION(lbpaper_kb_pgup){(Tlbpaper_p(obj_p))->pg_up();}
// **********************************************************************
#pragma argsused
static KEYB_ACTION(lbpaper_kb_pgdn){(Tlbpaper_p(obj_p))->pg_dn();}
// **********************************************************************
#pragma argsused
static KEYB_ACTION(lbpaper_kb_home){(Tlbpaper_p(obj_p))->home();}
// **********************************************************************
#pragma argsused
static KEYB_ACTION(lbpaper_kb_end){(Tlbpaper_p(obj_p))->end();}
// **********************************************************************
#pragma argsused
static KEYB_ACTION(lbpaper_kb_up10){(Tlbpaper_p(obj_p))->up10();}
// **********************************************************************
#pragma argsused
static KEYB_ACTION(lbpaper_kb_dn10){(Tlbpaper_p(obj_p))->dn10();}
// **********************************************************************
#pragma argsused
static KEYB_ACTION(lbpaper_kb_lf){(Tlbpaper_p(obj_p))->lf();}
// **********************************************************************
#pragma argsused
static KEYB_ACTION(lbpaper_kb_rt){(Tlbpaper_p(obj_p))->rt();}
// **********************************************************************
#pragma argsused
static KEYB_ACTION(lbpaper_kb_lf_pg){(Tlbpaper_p(obj_p))->lf_pg();}
// **********************************************************************
#pragma argsused
static KEYB_ACTION(lbpaper_kb_rt_pg){(Tlbpaper_p(obj_p))->rt_pg();}
// **********************************************************************
#pragma argsused
static KEYB_ACTION(lbpaper_kb_lf_home){(Tlbpaper_p(obj_p))->lf_home();}
// **********************************************************************
#pragma argsused
static KEYB_ACTION(lbpaper_kb_rt_end){(Tlbpaper_p(obj_p))->rt_end();}
// **********************************************************************
#pragma argsused
static KEYB_ACTION(lbpaper_kb_lf_tab){(Tlbpaper_p(obj_p))->lf_tab();}
// **********************************************************************
#pragma argsused
static KEYB_ACTION(lbpaper_kb_rt_tab){(Tlbpaper_p(obj_p))->rt_tab();}
// **********************************************************************
#pragma argsused
static KEYB_ACTION(lbpaper_kb_sw_wrap){(Tlbpaper_p(obj_p))->sw_wrap();}
// **********************************************************************
#pragma argsused
static KEYB_ACTION(lbpaper_kb_sw_hex){(Tlbpaper_p(obj_p))->sw_hex();}

// **********************************************************************
//-  
void	Tlbpaper::sw_active()
{
	if(!is_active)
	 {
	   is_active=1;
	   //new keys
	   old_key[TPAPER_KEYCMD_UP]=desktop_p->keyb_p->replace( TPAPER_KB_UP_KEY,lbpaper_kb_up,this );
	   old_key[TPAPER_KEYCMD_DN]=desktop_p->keyb_p->replace( TPAPER_KB_DN_KEY,lbpaper_kb_dn,this );
	   old_key[TPAPER_KEYCMD_PGUP]=desktop_p->keyb_p->replace( TPAPER_KB_PGUP_KEY,lbpaper_kb_pgup,this );
	   old_key[TPAPER_KEYCMD_PGDN]=desktop_p->keyb_p->replace( TPAPER_KB_PGDN_KEY,lbpaper_kb_pgdn,this );
	   old_key[TPAPER_KEYCMD_HOME]=desktop_p->keyb_p->replace( TPAPER_KB_HOME_KEY,lbpaper_kb_home,this );
	   old_key[TPAPER_KEYCMD_END]=desktop_p->keyb_p->replace( TPAPER_KB_END_KEY,lbpaper_kb_end,this );
	   old_key[TPAPER_KEYCMD_UP10]=desktop_p->keyb_p->replace( TPAPER_KB_UP10_KEY,lbpaper_kb_up10,this );
	   old_key[TPAPER_KEYCMD_DN10]=desktop_p->keyb_p->replace( TPAPER_KB_DN10_KEY,lbpaper_kb_dn10,this );

	   old_key[TPAPER_KEYCMD_LF]=desktop_p->keyb_p->replace( TPAPER_KB_LF_KEY,lbpaper_kb_lf,this );
	   old_key[TPAPER_KEYCMD_RT]=desktop_p->keyb_p->replace( TPAPER_KB_RT_KEY,lbpaper_kb_rt,this );
	   old_key[TPAPER_KEYCMD_LF_PG]=desktop_p->keyb_p->replace( TPAPER_KB_LF_PG_KEY,lbpaper_kb_lf_pg,this );
	   old_key[TPAPER_KEYCMD_RT_PG]=desktop_p->keyb_p->replace( TPAPER_KB_RT_PG_KEY,lbpaper_kb_rt_pg,this );
	   old_key[TPAPER_KEYCMD_LF_HOME]=desktop_p->keyb_p->replace( TPAPER_KB_LF_HOME_KEY,lbpaper_kb_lf_home,this );
	   old_key[TPAPER_KEYCMD_RT_END]=desktop_p->keyb_p->replace( TPAPER_KB_RT_END_KEY,lbpaper_kb_rt_end,this );
	   old_key[TPAPER_KEYCMD_LF_TAB]=desktop_p->keyb_p->replace( TPAPER_KB_LF_TAB_KEY,lbpaper_kb_lf_tab,this );
	   old_key[TPAPER_KEYCMD_RT_TAB]=desktop_p->keyb_p->replace( TPAPER_KB_RT_TAB_KEY,lbpaper_kb_rt_tab,this );

	   old_key[TPAPER_KEYCMD_SW_WRAP]=desktop_p->keyb_p->replace( TPAPER_KB_SW_WR_KEY,lbpaper_kb_sw_wrap,this );
	   old_key[TPAPER_KEYCMD_SW_HEX]=desktop_p->keyb_p->replace( TPAPER_KB_SW_HEX_KEY,lbpaper_kb_sw_hex,this );
	   //children
	   Twin::sw_active();
	 }
	else
	 {
	   is_active=0;
	   //children
	   Twin::sw_active();
	   // 
	   desktop_p->keyb_p->install( TPAPER_KB_SW_HEX_KEY, old_key[TPAPER_KEYCMD_SW_HEX]);
	   desktop_p->keyb_p->install( TPAPER_KB_SW_WR_KEY, old_key[TPAPER_KEYCMD_SW_WRAP]);

	   desktop_p->keyb_p->install( TPAPER_KB_RT_TAB_KEY, old_key[TPAPER_KEYCMD_RT_TAB]);
	   desktop_p->keyb_p->install( TPAPER_KB_LF_TAB_KEY, old_key[TPAPER_KEYCMD_LF_TAB]);
	   desktop_p->keyb_p->install( TPAPER_KB_RT_END_KEY, old_key[TPAPER_KEYCMD_RT_END]);
	   desktop_p->keyb_p->install( TPAPER_KB_LF_HOME_KEY, old_key[TPAPER_KEYCMD_LF_HOME]);
	   desktop_p->keyb_p->install( TPAPER_KB_RT_PG_KEY, old_key[TPAPER_KEYCMD_RT_PG]);
	   desktop_p->keyb_p->install( TPAPER_KB_LF_PG_KEY, old_key[TPAPER_KEYCMD_LF_PG]);
	   desktop_p->keyb_p->install( TPAPER_KB_RT_KEY, old_key[TPAPER_KEYCMD_RT]);
	   desktop_p->keyb_p->install( TPAPER_KB_LF_KEY, old_key[TPAPER_KEYCMD_LF]);

	   desktop_p->keyb_p->install( TPAPER_KB_DN10_KEY, old_key[TPAPER_KEYCMD_DN10]);
	   desktop_p->keyb_p->install( TPAPER_KB_UP10_KEY, old_key[TPAPER_KEYCMD_UP10]);
	   desktop_p->keyb_p->install( TPAPER_KB_END_KEY, old_key[TPAPER_KEYCMD_END]);
	   desktop_p->keyb_p->install( TPAPER_KB_HOME_KEY, old_key[TPAPER_KEYCMD_HOME]);
	   desktop_p->keyb_p->install( TPAPER_KB_PGDN_KEY, old_key[TPAPER_KEYCMD_PGDN]);
	   desktop_p->keyb_p->install( TPAPER_KB_PGUP_KEY, old_key[TPAPER_KEYCMD_PGUP]);
	   desktop_p->keyb_p->install( TPAPER_KB_DN_KEY, old_key[TPAPER_KEYCMD_DN]);
	   desktop_p->keyb_p->install( TPAPER_KB_UP_KEY, old_key[TPAPER_KEYCMD_UP]);
	 }
}

// **********************************************************************

