#include "vbrouser\all.h"

#include "winitems.h"
#include "vbrouser\vbrouser.h"
#include "vbrouser\vbpaper.h"
#include "vbrouser\vbrou_rs.h"

/*
	 VBROUSER
*/

// **********************************************************************
#pragma argsused
static KEYB_ACTION(vbrouser_kb_up){(Tvbpaper_p(obj_p))->up();}
// **********************************************************************
#pragma argsused
static KEYB_ACTION(vbrouser_kb_dn){(Tvbpaper_p(obj_p))->dn();}
// **********************************************************************
#pragma argsused
static KEYB_ACTION(vbrouser_kb_pgup){(Tvbpaper_p(obj_p))->pg_up();}
// **********************************************************************
#pragma argsused
static KEYB_ACTION(vbrouser_kb_pgdn){(Tvbpaper_p(obj_p))->pg_dn();}

// **********************************************************************
//-  
void	Tvbpaper::sw_active()
{

	if(!is_active)
	 {
	   is_active=1;
	   //new keys
	   old_key[TVBROUSER_KEYCMD_UP]=desktop_p->keyb_p->replace( CP_KB_UP_KEY,vbrouser_kb_up,this );
	   old_key[TVBROUSER_KEYCMD_DN]=desktop_p->keyb_p->replace( CP_KB_DN_KEY,vbrouser_kb_dn,this );
	   old_key[TVBROUSER_KEYCMD_PGUP]=desktop_p->keyb_p->replace( CP_KB_PGUP_KEY,vbrouser_kb_pgup,this );
	   old_key[TVBROUSER_KEYCMD_PGDN]=desktop_p->keyb_p->replace( CP_KB_PGDN_KEY,vbrouser_kb_pgdn,this );

	   //children
	   Twin::sw_active();
	 }
	else
	 {
	   is_active=0;
	   //children
	   Twin::sw_active();
	   // 
	   desktop_p->keyb_p->install( CP_KB_PGDN_KEY, old_key[TVBROUSER_KEYCMD_PGDN]);
	   desktop_p->keyb_p->install( CP_KB_PGUP_KEY, old_key[TVBROUSER_KEYCMD_PGUP]);
	   desktop_p->keyb_p->install( CP_KB_DN_KEY, old_key[TVBROUSER_KEYCMD_DN]);
	   desktop_p->keyb_p->install( CP_KB_UP_KEY, old_key[TVBROUSER_KEYCMD_UP]);
	 }
}

// **********************************************************************

