#ifndef VIEW_H
#define VIEW_H

// **********************************************************************
// **********************************************************************
//
class	Tview;
typedef	Tview *Tview_p;

//   
typedef Tlnmeta Tvmmeta;
typedef Tvmmeta *Tvmmeta_p;

// **********************************************************************
// **********************************************************************
// p 
typedef	enum
{
	TVIEW_KEYCMD_EXIT=0,
	TVIEW_KEYCMD_EXIT2,
	TVIEW_KEYCMD_HELP,
	TVIEW_KEYCMD_SW_STATUS,
	TVIEW_KEYCMD_SW_RESOLUTION,
	TVIEW_KEYCMD_SEL_SRC_CODE,
	TVIEW_KEYCMD_SEL_DST_CODE,
	TVIEW_KEYCMDS
}t_view_keycmds;

// **********************************************************************
//
class	Tview: public Tcwin
{
public:
	//   (   )
	Tview();
	virtual ~Tview();

private:
	// 
	char	exit_pressed;

//   
public:
	// 
	Tvmmeta_p	filter_p;
	//  desktop
	int	cur_resolution;
	// -
	char	en_status;

//  selector
public:
	// 
	virtual void	view( Tvmmeta& filter );

//  
public:
	// p 
	virtual void exit();
	virtual void sw_status();
	virtual void sw_resolution();
	virtual void help();

	//   
	virtual void select_src_code();
	//   
	virtual void select_dst_code();

private:
	//  
	virtual void select_code_dlg(char src);

//   
public:
	//   
	void	sw_active();

private:
	// 
	Tkeyb_action	old_key[TVIEW_KEYCMDS];

	friend class Tview_paper;
};

// **********************************************************************
#endif
