#ifndef TSTRING_H
#define TSTRING_H

#include <string.h>

/*
	WIN32 version
*/

/*
	
	 1.   
	 2.   
	          ==(equ)  >, < (less)
	           
	        
	     operator unary '-'  char_p  std string.h
	     /    
	     
	        +=
	          +
	     ( )
	 3.   string.h
	 4. Win32    strlen(NULL)-     
	       len() -    0   strlen
	            const   
	      -      


	      cstring      
*/

// ***********************************************************************
class	Tstring;
typedef Tstring* Tstring_p;

typedef enum
{
	Tstring_compare_less=0,
	Tstring_compare_more
}t_tstring_compare;

// ***********************************************************************
//     
class	Tstring_access;

// ***********************************************************************
//    >=   0 -   
#define DEF_TSTRING_MAXLEN	0
class	Tstring: public Toos
{
public:
	//   -  
	Tstring( char_p src=NULL, u_int maxlen=DEF_TSTRING_MAXLEN );
	//       
	Tstring( Tstring& src );

	~Tstring();

// 
	//   ,   . 
	//  
	SELF_Toos

// 
public:

	//     :      
	void	  	compact();
	//   
	Tstring&	operator ~();

	//  
	inline	int	len()
	 {return data_p?strlen(data_p):0;}

// :
public:
	//   /   ==
	inline	void	equ_min_size( char ms=1 )
	 { compare_equ_min_size=ms; }
	//   /   <
	inline	void	less_min_size( char ms=1 )
	 { compare_less_min_size=ms; }

	//  :
	//   0
	//  [ : equ_min_size=0]
	//    [  : equ_min_size=1]
	//  :
	//   0
	//  [ : less_min_size=0]
	//       [   : less_min_size=1 ]
	char		operator ==( Tstring& str );
	char		operator <( Tstring& str );
	char 	 	operator >( Tstring& str );

	//  equ_min_size
	inline char operator != ( Tstring& str )
	 { return (char)!(*this == str); }

	//  less_min_size
	inline char operator <= ( Tstring& str )
	 { return (char)!( *this > str ); }
	inline char operator >= ( Tstring& str )
	 { return (char)!( *this < str ); }

//
public:
	Tstring& 	 operator =( Tstring& srt );
	Tstring& 	 operator +=( Tstring& str );

	Tstring 	 operator +( Tstring& str );

	//  char_p
	//operator char_p();-  printf  string.h
	//     (char_p)str -  
	//    "-"
	char_p		 operator -();
	// temporary used
	Tstring& 	 operator =( char_p src );
	Tstring& 	 operator +=( char_p src );


protected:
	char_p	data_p;
	// 
	u_int	mem_size;
	// 
	char	compare_equ_min_size;
	char	compare_less_min_size;

	char  compare ( Tstring& str, t_tstring_compare tstring_compare );

	friend	class Tstring_access;
};

// ***********************************************************************
//     
class	Tstring_access
{
public:
	inline	char_p&	a_data_p(Tstring& s){return s.data_p;}
	inline	u_int&	a_mem_size(Tstring& s){return s.mem_size;}
};

// ***********************************************************************
#endif
