#ifndef WINITEMS_H
#define WINITEMS_H

/*
      easywin
     
     
*/

// ****************************************************************
//  
class	Tcwin;
typedef Tcwin *Tcwin_p;

//
class 	Tdialog;
typedef Tdialog *Tdialog_p;

// ****************************************************************
//    
#define CWIN_CAPTION	 (0)
#define CWIN_PAPER	 (1)

//  
class	Tcwin: public Twin
{
public:
	Tcwin();

//     
public:
	//  
	virtual void set_caption(char_p caption,char skip_set_size=0);
	//   
	virtual void set_paper(Twin_p paper_p,char skip_set_size=0);

	//    
	virtual Twin_p get_caption();
	//    
	virtual Twin_p get_paper();

//   
public:
	//   -    
	void	set_size(u_int lx,u_int ly);
};

// ****************************************************************
//
class 	Tdialog: public Tcwin
{
//  
public:
	//  c    
	virtual u_int execute(char clear_keys=0);

	//? Enter  ESC
	inline char get_exit_status(){return selected;}

	//  /
	char	on_exit;
	char	selected;

//   
public:
	//   -    
	//  last_x,last_y  
	void 	set_size(u_int new_lx,u_int new_ly);

	//   
	void 	sw_active();

private:
	// 
	Tkeyb_action	old_key[2];
};
// Tdialog::execute()
#define DLG_CANCEL	(0)
#define DLG_OK		(1)
#define DLG_CLEAR_KEYS  (1)

// ****************************************************************
#endif

