#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#include <mydef.h>
#include <tstring.h>

#pragma hdrstop

#include <unicode.h>

#include "plist\plist.h"

#include "tstream\tstream.h"
#include "linestrm\linestrm.h"
#include "linestrm\lnstrmh.h"
#include "linestrm\lnstrmt.h"
#include "linestrm\lnstrmtu.h"
#include "linestrm\lnstrmtw.h"
#include "linestrm\lnstrmtx.h"

#include "linestrm\lnmeta\lnmeta.h"
#include "linestrm\lnmeta\lnmetam.h"

// **********************************************************************
//    
//  
// **********************************************************************
//  
t_err	Tlnmeta_mode::set_submode_number(u_int mode_number)
{
Tlnmeta_mode_p	p;

	p=Tlnmeta_mode_p(submodes[mode_number]);
	return (p)?p->mode_prepare():ERR_BOUND;
}

// **********************************************************************
//   
t_err	Tlnmeta_mode::mode_prepare()
{
Tlnmeta_mode_p	p;

	p=get_submode();
	return (p)?p->mode_prepare():ERR_NO;
}

// **********************************************************************
//    - 
// **********************************************************************
//    
#define GET_P \
Tlnmeta_mode_lnstream_p		p=(Tlnmeta_mode_lnstream_p)get_submode();

// **********************************************************************
//  
// **********************************************************************
//    ( tty \?)  
//return NULL on error or feof()
//Tstring_p need external delete
Tstring_p Tlnmeta_mode_lnstream_sel::read()
{
GET_P
	  if(!p)return 0;
	  return p->read();
}

// **********************************************************************
//   line,  ! ERR_BOUND
t_err	Tlnmeta_mode_lnstream_sel::seek(u_int line)
{
GET_P
	  if(!p)return ERR_DENIED;
	  return p->seek(line);
}

// **********************************************************************
//       
u_int	Tlnmeta_mode_lnstream_sel::get_lines()
{
GET_P
	  if(!p)return 0;
	  return p->get_lines();
}

// **********************************************************************
//  seek
u_int	Tlnmeta_mode_lnstream_sel::get_percent()
{
GET_P
	  if(!p)return ERR_DENIED;
	  return p->get_percent();
}

// **********************************************************************
//     -1 on error
u_int	Tlnmeta_mode_lnstream_sel::get_line()
{
GET_P
	  if(!p)return ERR_DENIED;
	  return p->get_line();
}

// **********************************************************************
//  seek
u_int	Tlnmeta_mode_lnstream_sel::get_last_seek()
{
GET_P
	  if(!p)return ERR_DENIED;
	  return p->get_last_seek();
}

// **********************************************************************
//    

//     ,  ! ERR_BOUND
//      
t_err	Tlnmeta_mode_lnstream_sel::next_line()
{
GET_P
	  if(!p)return ERR_DENIED;
	  return p->next_line();
}

// **********************************************************************
// :   lx
void 	Tlnmeta_mode_lnstream_sel::line_discipline(u_int lx)
{
GET_P
	  if(p)p->line_discipline(lx);
	  //warn("Tlnmeta_mode_lnstream_sel::line_discipline(u_int)");
}

// **********************************************************************
//  
//  Tstring   
#pragma argsused
void 	Tlnmeta_mode_lnstream_sel::convert(Tstring& str)
{
	//
}

// **********************************************************************
//      ( c )
// **********************************************************************
//   
	Tlnmeta::Tlnmeta(Tstream& user_stream):
		Tlnmeta_mode_lnstream_sel(user_stream)
{
Tlnmeta_mode_p	p[2];

	p[0]=new Tlnmeta_mode_text(user_stream);
	p[1]=new Tlnmeta_mode_hex(user_stream);
	if((!p[0])||(!p[1])){err(ERR_NOMEM);return;}

	submodes[0];
	submodes+=Tlist_item_p(p[0]);
	submodes++;
	submodes+=Tlist_item_p(p[1]);

	set_submode_number(0);
}

// **********************************************************************
/*
#include "tstream\tfile.h"

Tlnmeta<Tfile>	lnmeta;
Tstream_p	p;
Tlnmeta<*p>	lnmeta;

Tfile		f;

Tlnmeta		lnmeta(f);
*/

// **********************************************************************

