#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#include <mydef.h>
#include <tstring.h>

#pragma hdrstop

#include <unicode.h>

#include "tstream\tstream.h"
#include "linestrm\linestrm.h"
#include "linestrm\lnstrmt.h"

// **********************************************************************
// 
// **********************************************************************
//  , / . . 
t_err	Tlnstream_text::obj_load(FILE *fi)
{
t_err		res;

	if(!fi)return err(ERR_ZPAR);

	if( (res=Tline_stream::obj_load(fi))!=ERR_NO )
	 return res;

	return ERR_NO;
}

// **********************************************************************
//  , / . . 
t_err	Tlnstream_text::obj_save(FILE *fo)
{
t_err		res;

	if(!fo)return err(ERR_ZPAR);

	if( (res=Tline_stream::obj_save(fo))!=ERR_NO )
	 return res;

	return ERR_NO;
}

// **********************************************************************
//  
// **********************************************************************
//    ( tty \?)
//  return NULL on error or feof()
//      wrap 
//     Tlnstream_text2  next_line
Tstring_p	Tlnstream_text::read()
{
Tstring_p	p;
/*
	  {
	   char s[80];
	   sprintf(s,"Tlnstream_text::read\nline %u",last_line[is_wrap]);
	   warn(s);
	  }
*/
	//EOF found during read
	if(next_line()!=ERR_NO)
	 {
	  set_pos(0,SEEK_END);
	 }

	//no more lines
	if(!converted_line_size)return NULL;

	p=new Tstring(0,converted_line_size);
	if(!p){err(ERR_NOMEM);return NULL;}

	//if only \n or empty
	set_pos(get_pos()-stream_line_size);
	read_block(-*p,stream_line_size);
	//last \0
	*((-*p)+stream_line_size)=0;

	//  
	convert(*p);

	return p;
}

// **********************************************************************
//  
void	Tlnstream_text::convert(Tstring& str)
{
u_int		i,j;
char_p		p;

/*
{
 char s[160];
 sprintf(s,"NL=0x%X\ncls=%u\ndls=%u\nfls=%u",get_pos(),converted_line_size, displayed_line_size, stream_line_size);
 warn(s);
}
*/
	p=-str;
	if(!p){err(ERR_ZDATA);return;}

	//convert all exclude \t
	for(i=0;i<stream_line_size;i++)
	 {
	  switch(*p)
	   {
	    //skip \r \n
	    case '\n':
	    case '\r':
	     memmove(p,p+1,stream_line_size-i);
	     break;

	    //pass \t
	    case '\t':
	     p++;
	     break;

	    //replace < ' ' to ' '
	    default:
	     if(u_char(*p)<32)*p=' ';
	     p++;
	   }
	 }
	*p=0;

	//expand tabs
	p=-str;
	j=str.len();
	for(i=0;i<j;i++)
	 {
	  //expand \t by ' '%(8)
	  if( (*p) == '\t' )
	   {
	    u_int	dx=i%8;
	    u_int	len;

	    len=str.len();
	    if(!dx)dx=8;

	    if( (len+7) > converted_line_size )
	     {
	      char s[80];
	      sprintf(s,"wrong 'converted_line_size'\n%u delta",u_int(converted_line_size-len) );
	      err2(ERR_BOUND,s);
	      return;
	     }

	    len=strlen(p+1);
	    //move all after \t including \0
	    memmove(p+dx,p+1,len+1);
	    memset(p,' ',dx);

	    p+=dx;
	   }
	  else p++;
	 }
	*p=0;

}

// **********************************************************************

