#include <stdio.h>
#include <stdlib.h>

#include <mydef.h>

#include "keys.h"
#include "keytbl.h"

/* *************************************************************** */
//   mod c   key ext:ascii
//() key   
t_err	keytbl_get_modkey( char ext, char ascii, int mod, int& key )
{
int	key_index;
u_int	l_ext,l_ascii;

	if( (abs(mod)>=KEY_MODS)||(abs(key)>=KEY_KEYS) )return err(ERR_BOUND);

	for( key_index=key; key_index<KEY_KEYS; key_index++ )
	 {
	  l_ext=keytbl_tbl[mod][key_index]>>8;
	  l_ascii=keytbl_tbl[mod][key_index]&0xff;

	  if(!(l_ext|l_ascii))continue;         //    0:0
	  if(l_ext!=ext)continue;
	  if(l_ascii!=ascii)continue;

	  key=key_index;
	  return ERR_NO;
	 }
	return ERR_NFOUND;
}

/* *************************************************************** */
//      mod:key
// ext:ascii   mod:key
t_err	keytbl_get_extascii( int mod, int key, char& ext, char& ascii )
{
	if( (abs(mod)>=KEY_MODS)||(abs(key)>=KEY_KEYS) ) return err(ERR_BOUND);

	ext=char(keytbl_tbl[mod][key]>>8);
	ascii=char(keytbl_tbl[mod][key]&0xff);

	if(!(ext|ascii))return ERR_NEXIST;  	//    0:0
	return ERR_NO;
}
/* *************************************************************** */
/*  mod:key to ext:ascii   */
extern	t_keytbl_tbl	keytbl_tbl;

/* *************************************************************** */
