#ifndef KEYTBL_H
#define KEYTBL_H
/*
	    
	getch() (ext:ascii)  mod:key  
	 -> ext:ascii
*/
//   mod
// key   
t_err	keytbl_get_modkey( char ext, char ascii, int mod, int& key );

//      mod:key
// ext:ascii   mod:key
t_err	keytbl_get_extascii( int mod, int key, char& ext, char& ascii );

/* *************************************************************** */
/*  mod:key to ext:ascii   */
typedef u_int t_keytbl_tbl[KEY_MODS][KEY_KEYS];
extern	t_keytbl_tbl	keytbl_tbl;

/* *************************************************************** */
/* *************************************************************** */
#define KEYTBL_FILE_VERSION	10
#define KEYTBL_FILE_SIGN_LEN	16
#define KEYTBL_FILE_SIGN	"DEF KEYTBLFILE\x01a"

typedef struct keytbl_file *t_keytbl_file_p;
typedef struct keytbl_file
{
	char	sign[KEYTBL_FILE_SIGN_LEN];
	u_Int	version;
	t_keytbl_tbl	tbl;

}t_keytbl_file;

//load global keytbl_tbl from keytbl_file
t_err	keytbl_load(char_p fname,t_keytbl_file& keytbl_file);
//save global keytbl_tbl to keytbl_file
t_err	keytbl_save(char_p fname,t_keytbl_file& keytbl_file);

/* *************************************************************** */
#endif
