#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <mydef.h>

#include "keys.h"
#include "keyb.h"
#include "keytbl.h"

/* ********************************************************************* */
void	kb_exit(Tkeyb_key,void_p);
void	kb_test(Tkeyb_key,void_p);

class	T
{
public:
	inline T(){a=0x0U;}
	friend void kb_T(Tkeyb_key,void_p);
	friend void kb_T2(Tkeyb_key,T*);
private:
	int	a;
};

#pragma argsused
void	kb_T(Tkeyb_key,void_p obj_p)
{
T 		*p;

	p=(T*)obj_p;
	printf("%04X\n",p->a++);
}

#pragma argsused
void	kb_T2(Tkeyb_key,T *obj_p)
{
	printf("%04X\n",obj_p->a--);
}

/* ********************************************************************* */
void	main()
{
Tkeyb		keyb;
T		aT;

	keyb.install(Tkeyb_key(0,27),kb_exit);
	keyb.install(Tkeyb_key(0,'T'),kb_test);
	keyb.install(Tkeyb_key(0,'t'),kb_test);

	keyb.install(Tkeyb_key(0,'O'),kb_T,&aT);
	keyb.install(Tkeyb_key(0,'o'),t_keyb_action_f(kb_T2),&aT);

	while(1)
	 {
	  keyb.action();
	 }
}

/* ********************************************************************* */
#pragma argsused
void	kb_exit(Tkeyb_key,void_p)
{
	exit(0);
}

#pragma argsused
void	kb_test(Tkeyb_key key,void_p)
{
static u_int count=0;

	printf("Enter %u by %c\n",++count,key.ascii);
}

/* ********************************************************************* */
