#ifndef LBPAPER_H
#define LBPAPER_H

// **********************************************************************
// **********************************************************************
//   Tline_metafile
class	Tlbpaper;
typedef Tlbpaper *Tlbpaper_p;

// **********************************************************************
//
typedef	enum
{
	//  
	TPAPER_KEYCMD_UP=0,
	TPAPER_KEYCMD_DN,
	TPAPER_KEYCMD_PGUP,
	TPAPER_KEYCMD_PGDN,
	TPAPER_KEYCMD_HOME,
	TPAPER_KEYCMD_END,
	TPAPER_KEYCMD_UP10,	// 10%
	TPAPER_KEYCMD_DN10,

	TPAPER_KEYCMD_LF,
	TPAPER_KEYCMD_RT,
	TPAPER_KEYCMD_LF_PG,
	TPAPER_KEYCMD_RT_PG,
	TPAPER_KEYCMD_LF_HOME,  // 
	TPAPER_KEYCMD_RT_END,   //     
	TPAPER_KEYCMD_LF_TAB,   //  8 
	TPAPER_KEYCMD_RT_TAB,   //  8 

	//
	TPAPER_KEYCMD_SW_WRAP,
	TPAPER_KEYCMD_SW_HEX,

	//
	TPAPER_KEYCMD_SEARCH,

	TPAPER_KEYCMDS
}t_lbpaper_keycmds;

// **********************************************************************
// **********************************************************************
//   Tline_metafile
class	Tlbpaper:public Twin
{
public:
	//  
	Tlbpaper();
	virtual ~Tlbpaper();

//   
public:
	//   -    
	void 	set_size(u_int lx,u_int ly);

	//   
	void	sw_active();
private:
	// 
	Tkeyb_action	old_key[TPAPER_KEYCMDS];
	char		old_keys_saved;

//   e 
public:
	//  
	virtual void set_filter(Tlnmeta_mode_lnstream& filter);

	//     Tline_metafile
	virtual void set_page();

	//      
	//   
	virtual void sync_by_stream();

private:
	//      (lines))
	//u_int	get_page_max_line_size();

	// :     Tstrings
	void	zap();

	//  Tmeta  
	u_int	base_line;

	//   
	int	sx;

	// 
	Tlnmeta_mode_lnstream_p filter_p;

public:
	//   
	virtual void up();
	virtual void dn();
	virtual void pg_up();
	virtual void pg_dn();
	virtual void home();
	virtual void end();
	virtual void up10();
	virtual void dn10();

	virtual void lf();
	virtual void rt();
	virtual void lf_pg();
	virtual void rt_pg();
	virtual void lf_home();
	virtual void rt_end();
	virtual void lf_tab();
	virtual void rt_tab();

	// 
	char	en_sw_wrap;
	virtual void sw_wrap();
	char	en_sw_hex;
	virtual void sw_hex();

};

// **********************************************************************
#endif