#ifndef LBPAP_RS_H
#define LBPAP_RS_H

/*
	 lbPAPER
*/

// **********************************************************************
//   PAPER
static KEYB_ACTION(lbpaper_kb_up);
static KEYB_ACTION(lbpaper_kb_dn);
static KEYB_ACTION(lbpaper_kb_pgup);
static KEYB_ACTION(lbpaper_kb_pgdn);
static KEYB_ACTION(lbpaper_kb_home);
static KEYB_ACTION(lbpaper_kb_end);
static KEYB_ACTION(lbpaper_kb_up10);
static KEYB_ACTION(lbpaper_kb_dn10);

static KEYB_ACTION(lbpaper_kb_lf);
static KEYB_ACTION(lbpaper_kb_rt);
static KEYB_ACTION(lbpaper_kb_lf_pg);
static KEYB_ACTION(lbpaper_kb_rt_pg);
static KEYB_ACTION(lbpaper_kb_lf_home);
static KEYB_ACTION(lbpaper_kb_rt_end);
static KEYB_ACTION(lbpaper_kb_lf_tab);
static KEYB_ACTION(lbpaper_kb_rt_tab);

static KEYB_ACTION(lbpaper_kb_sw_wrap);
static KEYB_ACTION(lbpaper_kb_sw_hex);

// **********************************************************************
//  - PAPER
#define	TPAPER_KB_UP_KEY	Tkeyb_key(KEY_EXT,0x48)
#define	TPAPER_KB_DN_KEY	Tkeyb_key(KEY_EXT,0x50)
#define	TPAPER_KB_PGUP_KEY	Tkeyb_key(KEY_EXT,0x49)
#define	TPAPER_KB_PGDN_KEY	Tkeyb_key(KEY_EXT,0x51)
#define	TPAPER_KB_HOME_KEY	Tkeyb_key(KEY_EXT,0x84)
#define	TPAPER_KB_END_KEY	Tkeyb_key(KEY_EXT,0x76)
#define	TPAPER_KB_UP10_KEY	Tkeyb_key(KEY_EXT,0x8d)
#define	TPAPER_KB_DN10_KEY	Tkeyb_key(KEY_EXT,0x91)

#define	TPAPER_KB_LF_KEY	Tkeyb_key(KEY_EXT,0x4B)
#define	TPAPER_KB_RT_KEY	Tkeyb_key(KEY_EXT,0x4D)
#define	TPAPER_KB_LF_PG_KEY	Tkeyb_key(KEY_EXT,0x77)
#define	TPAPER_KB_RT_PG_KEY	Tkeyb_key(KEY_EXT,0x75)
#define	TPAPER_KB_LF_HOME_KEY	Tkeyb_key(KEY_EXT,0x47)
#define	TPAPER_KB_RT_END_KEY	Tkeyb_key(KEY_EXT,0x4F)
#define	TPAPER_KB_LF_TAB_KEY	Tkeyb_key(KEY_EXT,0x73)
#define	TPAPER_KB_RT_TAB_KEY	Tkeyb_key(KEY_EXT,0x74)

#define	TPAPER_KB_SW_WR_KEY	Tkeyb_key(KEY_EXT,0x3C)
#define	TPAPER_KB_SW_HEX_KEY	Tkeyb_key(KEY_EXT,0x3E)

// **********************************************************************
// **********************************************************************
#endif
