#ifndef VBPAPER_H
#define VBPAPER_H

// **********************************************************************
//  VBROUSER
// **********************************************************************
// 
class	Tvbpaper;
typedef Tvbpaper *Tvbpaper_p;

// ***********************************************************************
//
typedef	enum
{
	//  
	TVBROUSER_KEYCMD_UP=0,
	TVBROUSER_KEYCMD_DN,
	TVBROUSER_KEYCMD_PGUP,
	TVBROUSER_KEYCMD_PGDN,
	TVBROUSER_KEYCMDS
}t_vbrouse_keycmds;

// **********************************************************************
// 
class	Tvbpaper: public Twin
{
public:
	Tvbpaper();

//   
public:
	//   -    
	void 	set_size(u_int new_lx,u_int new_ly);

	//   
	void 	sw_active();

private:
	// 
	Tkeyb_action	old_key[TVBROUSER_KEYCMDS];

//   
public:
	//    
	virtual void set_list_for_select(Tplist& info,u_int preselected=0);

	//   
	virtual void set_page();

	//  
	virtual u_int get_selected();

private:
	//   
	Tplist_iterator_p info_p;

	// 
	u_int	selected_line;
	//    
	u_int	base_line;

//   
public:
	void	up();
	void	dn();
	void	pg_up();
	void	pg_dn();

	//friend class Tvbrouser;
};

// **********************************************************************
#endif

