#ifndef STATUS_H
#define STATUS_H

// **********************************************************************
// 
class	Tstatus;
typedef Tstatus *Tstatus_p;

//  
class	Tstatus_item;
typedef Tstatus_item *Tstatus_item_p;

// **********************************************************************
//  
class	Tstatus_item
{
public:
	//  
	inline Tstatus_item(Tview& aview):view(aview)
	 {
	  print_size=0;
	  en_trunc=0;
	  en_points=0;
	  right_points=0;
	 }

	//
	virtual Tstring& get_str()=0;

	//    0- if not used
	u_int	print_size;

	//       
	char	en_trunc;
	// 
	char	en_points;
	//  
	char	right_points;

protected:
	Tstring	str;

	//   
	Tview&	view;
};

// **********************************************************************
// 
class	Tstatus
{
public:
	//  
	Tstatus(Tview& view);
	virtual ~Tstatus();

	//     
	virtual Tstring& get_str();

	//     ref 
	Tplist	rlist;
	//     ref 
	Tplist	llist;

protected:
	//C  
	Tstring	str;

	//   
	Tview&	view;
};

// **********************************************************************
#endif