#include "vm_app.h"

#include "view\view_rs.h"

/*
	 VIEW
*/

// **********************************************************************
#pragma argsused
static KEYB_ACTION(view_kb_exit){(Tview_p(obj_p))->exit();}
// **********************************************************************
#pragma argsused
static KEYB_ACTION(view_kb_help){(Tview_p(obj_p))->help();}
// **********************************************************************
#pragma argsused
static KEYB_ACTION(view_kb_sw_status){(Tview_p(obj_p))->sw_status();}
// **********************************************************************
#pragma argsused
static KEYB_ACTION(view_kb_sw_resolution){(Tview_p(obj_p))->sw_resolution();}
// **********************************************************************
#pragma argsused
static KEYB_ACTION(view_kb_sel_srccode){(Tview_p(obj_p))->select_src_code();}
// **********************************************************************
#pragma argsused
static KEYB_ACTION(view_kb_sel_dstcode){(Tview_p(obj_p))->select_dst_code();}

// **********************************************************************
//-  
void	Tview::sw_active()
{
	if(!is_active)
	 {
	  is_active=1;
	  //new keys
	  old_key[TVIEW_KEYCMD_EXIT]=desktop_p->keyb_p->replace( TVIEW_KB_EXIT_KEY,view_kb_exit,this );
	  old_key[TVIEW_KEYCMD_EXIT2]=desktop_p->keyb_p->replace( TVIEW_KB_EXIT2_KEY,view_kb_exit,this );
	  old_key[TVIEW_KEYCMD_HELP]=desktop_p->keyb_p->replace( TVIEW_KB_HELP_KEY,view_kb_help,this );
	  old_key[TVIEW_KEYCMD_SW_STATUS]=desktop_p->keyb_p->replace( TVIEW_KB_SW_ST_KEY,view_kb_sw_status,this );
	  old_key[TVIEW_KEYCMD_SW_RESOLUTION]=desktop_p->keyb_p->replace( TVIEW_KB_SW_RS_KEY,view_kb_sw_resolution,this );
	  old_key[TVIEW_KEYCMD_SEL_SRC_CODE]=desktop_p->keyb_p->replace( TVIEW_KB_SEL_SCODE_KEY,view_kb_sel_srccode,this );
	  old_key[TVIEW_KEYCMD_SEL_DST_CODE]=desktop_p->keyb_p->replace( TVIEW_KB_SEL_DCODE_KEY,view_kb_sel_dstcode,this );
	  //children
	  Twin::sw_active();
	 }
	else
	 {
	  is_active=0;
	  //children
	  Twin::sw_active();
	  // 
	  desktop_p->keyb_p->install( TVIEW_KB_SEL_DCODE_KEY, old_key[TVIEW_KEYCMD_SEL_DST_CODE]);
	  desktop_p->keyb_p->install( TVIEW_KB_SEL_SCODE_KEY, old_key[TVIEW_KEYCMD_SEL_SRC_CODE]);
	  desktop_p->keyb_p->install( TVIEW_KB_SW_RS_KEY, old_key[TVIEW_KEYCMD_SW_RESOLUTION]);
	  desktop_p->keyb_p->install( TVIEW_KB_SW_ST_KEY, old_key[TVIEW_KEYCMD_SW_STATUS]);
	  desktop_p->keyb_p->install( TVIEW_KB_HELP_KEY, old_key[TVIEW_KEYCMD_HELP]);
	  desktop_p->keyb_p->install( TVIEW_KB_EXIT2_KEY, old_key[TVIEW_KEYCMD_EXIT2]);
	  desktop_p->keyb_p->install( TVIEW_KB_EXIT_KEY, old_key[TVIEW_KEYCMD_EXIT]);
	 }
}

// **********************************************************************
